<?php
class ControllerStep2 extends Controller {
	private $error = array();
	
	public function index() {
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->redirect(HTTP_SERVER . 'index.php?route=step_3');
		}

		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';	
		}
		
		$this->data['action'] = HTTP_SERVER . 'index.php?route=step_2';

		$this->data['config_catalog'] = DIR_OPENCART . 'config.php';
		$this->data['config_admin'] = DIR_OPENCART . 'admin/config.php';
		
		$this->data['cache'] = DIR_SYSTEM . 'cache';
		$this->data['logs'] = DIR_SYSTEM . 'logs';
		$this->data['image'] = DIR_OPENCART . 'image';
		$this->data['image_cache'] = DIR_OPENCART . 'image/cache';
		$this->data['image_data'] = DIR_OPENCART . 'image/data';
		$this->data['download'] = DIR_OPENCART . 'download';

		$this->children = array(
			'header',
			'footer'
		);
		
		$this->template = 'step_2.tpl';
		
		$this->response->setOutput($this->render(TRUE));
	}
	
	private function validate() {
		if (phpversion() < '5.0') {
			$this->error['warning'] = 'Attention, vous devez utiliser PHP5 ou sup&eacute;rieur pour utiliser OpenCart !';
		}

		if (!ini_get('file_uploads')) {
			$this->error['warning'] = 'Attention, <b>file_uploads</b> doit &ecirc;tre activ&eacute; !';
		}
	
		if (ini_get('session.auto_start')) {
			$this->error['warning'] = 'Attention, OpenCart ne fonctionnera pas avec <b>session.auto_start</b> de permis !';
		}

		if (!extension_loaded('mysql')) {
			$this->error['warning'] = 'Attention, l\'extension MySQL doit &ecirc;tre charg&eacute; pour utiliser OpenCart !';
		}

		if (!extension_loaded('gd')) {
			$this->error['warning'] = 'Attention, l\'extension GD doit &ecirc;tre charg&eacute; pour utiliser OpenCart !';
		}

		if (!extension_loaded('zlib')) {
			$this->error['warning'] = 'Attention, l\'extension ZLIB doit &ecirc;tre charg&eacute; pour utiliser OpenCart !';
		}
	
		if (!is_writable(DIR_OPENCART . 'config.php')) {
			$this->error['warning'] = 'Attention, le fichier <b>config.php</b> doit &ecirc;tre autoris&eacute; en &eacute;criture pour installer OpenCart !';
		}
				
		if (!is_writable(DIR_OPENCART . 'admin/config.php')) {
			$this->error['warning'] = 'Attention, le fichier <b>admin/config.php</b> doit &ecirc;tre autoris&eacute; en &eacute;criture pour installer OpenCart !';
		}

		if (!is_writable(DIR_SYSTEM . 'cache')) {
			$this->error['warning'] = 'Attention, le r&eacute;pertoire <b>Cache</b> doit &ecirc;tre autoris&eacute; en &eacute;criture pour installer OpenCart !';
		}
		
		if (!is_writable(DIR_SYSTEM . 'logs')) {
			$this->error['warning'] = 'Attention, le r&eacute;pertoire <b>Logs</b> doit &ecirc;tre autoris&eacute; en &eacute;criture pour installer OpenCart !';
		}
		
		if (!is_writable(DIR_OPENCART . 'image')) {
			$this->error['warning'] = 'Attention, le r&eacute;pertoire <b>Image</b> doit &ecirc;tre autoris&eacute; en &eacute;criture pour installer OpenCart !';
		}

		if (!is_writable(DIR_OPENCART . 'image/cache')) {
			$this->error['warning'] = 'Attention, le r&eacute;pertoire <b>Image/cache</b> doit &ecirc;tre autoris&eacute; en &eacute;criture pour installer OpenCart !';
		}
		
		if (!is_writable(DIR_OPENCART . 'image/data')) {
			$this->error['warning'] = 'Attention, le r&eacute;pertoire <b>Image/data</b> doit &ecirc;tre autoris&eacute; en &eacute;criture pour installer OpenCart !';
		}
		
		if (!is_writable(DIR_OPENCART . 'download')) {
			$this->error['warning'] = 'Attention, le r&eacute;pertoire <b>Download</b> doit &ecirc;tre autoris&eacute; en &eacute;criture pour installer OpenCart !';
		}
		
    	if (!$this->error) {
      		return TRUE;
    	} else {
      		return FALSE;
    	}
	}
}
?>